# Authenta SDK
This is the official SDK for Micron's Authenta devices.

## Requirements
The Authenta SDK requires python version **3.6+**. Installing the SDK will also install the requisite third-party packages `grpcio` and `grpcio-tools`.

## Installation
**NOTE: Currently, the Authenta SDK only supports Linux environments.**

### Setup
To install the Authenta SDK, we suggest using a virtual environment using the
`virtualenv` package. This can be accomplished by doing the following:

```bash
python3 -m pip install virtualenv
virtualenv env
source env/bin/activate
```

Move the `libmbedcrypto.so.3` file to a directory, and run:

```bash
export LD_LIBRARY_PATH=<path to libmbedcrypto.so.3>
```

### Installing the SDK directly
From here, you can install the SDK by installing directly:

```bash
python setup.py install
```

### Building a pip wheel
A pip wheel file can be generated for distribution by running:

```bash
python setup.py bdist_wheel
```

This will produce the `dist/authenta-0.1.0-py3-none-any.whl` file, which can be installed by running

```bash
python -m pip install dist/authenta-0.1.0-py3-none-any.whl
```