import ctypes as ct

# ---------------------------------------------
# python to 'C' bridge functions
# ---------------------------------------------
def int2c_int(i):
    return ct.c_int(i)

def int_ptr(i=None):
    return  ct.POINTER(ct.c_int) if i == None else ct.pointer(i)

def char_ptr(c=None):
    return ct.POINTER(ct.c_char_p) if c == None else ct.pointer(c)

def str2bytes(s):
    return bytes(s, 'utf-8')

def hexstr2bytes(s):
    return bytes.fromhex(s)

def str2c_str(s):
    return (ct.c_char_p)(bytes(s, 'utf-8'))

def str2c_buff(s, sz):
    return (ct.c_ubyte*sz)(*s)

def str2c_buffp(s, sz):
    return ct.pointer((ct.c_ubyte*sz)(*s))

def bytes2c_buff(b, sz):
    return (ct.c_ubyte*sz)(*b)
    
def ptr2struct(struct_):
    return ct.POINTER(struct_)

def ptr2obj(obj_):
    return ct.pointer(obj_)

def bool2c_bool(b):
    return (ct.c_bool(b))
