import enum
from .authenta_device import DeviceType

class EpPlatformRetCode(enum.Enum):
  EP_OK = 0
  EP_ERROR = 1

class PlatformReturnType:
  status = None
  buffer = None

  def __init__(self, status, buf=None):
    self.status = status
    self.buffer = buf

class EndpointPlatform:
  """ Interface for endpoint platforms
  """
  def exec_on_device(self, device_type: DeviceType, cmd):
    raise NotImplementedError

  def acquire_device(self, device_type: DeviceType):
    raise NotImplementedError

  def release_device(self, device_type: DeviceType):
    raise NotImplementedError

  def is_device_acquired(self):
    raise NotImplementedError
