import json
import logging


class Envr:
  def __init__(self, dn, ifn):
    # command vars
    self._devices_json = ifn
    self.device_name = dn
    self.ep_ip_address = None
    self.dev_pth = None
    self.devices_ht = None
    self.device_ht = None
    self.logger = logging.getLogger(__name__)
    self.logger.addHandler(logging.NullHandler()) # avoid exception in case no other handler is added

  def load_JSON_DB(self, json_DB):
    try:
      ht_ = json.load(json_DB)
    except json.decoder.JSONDecodeError as ex:
      self.logger.critical("failed to load devices.json file {}: {}".format(self._devices_json.name, ex.msg))
      exit()

    return ht_

  def select_device(self):
    try:
      self.device_ht = self.devices_ht[self.device_name]
    except KeyError:
      self.logger.critical("device name not found:{}".format(self.device_name))
      exit()

  def device2ip_addr(self):
    try:
      self.ep_ip_address = self.device_ht["endpoint_ip"]
    except KeyError:
      self.logger.critical("'endpoint_ip', key not found in json device datastructure")
      exit()

  def device2fs_path(self):
    try:
      self.dev_pth = self.device_ht["endpoint_fn"]
    except KeyError:
      self.logger.critical("'endpoint_fn', key not found in json device datastructure")
      exit()

  def setup(self):
    # load device/map device attribute data
    self.devices_ht = self.load_JSON_DB(self._devices_json)
    self.select_device()
    self.device2ip_addr()
    self.device2fs_path()
