import copy
from .cmd_error_code import NaxosCmdErrorCode


class NaxosCmdErrorCode_1_5(NaxosCmdErrorCode):
  """ Naxos command error parsing implementation for 1.5 device
  """

  # Standard errors map (for all commands)
  std_error_map = copy.copy(NaxosCmdErrorCode.std_error_map)

  # Individual function errors maps
  error_map = copy.copy(NaxosCmdErrorCode.error_map)
  error_map['deprovision_crtm'][5] += '; or Half Device Swap active is set'
  error_map['replace_srk'][1] = 'Option #1/#3 and Micron key already set'
  error_map['auth_modify'][0x38] = 'Option #3 and Half_Device_Swap_Enable is not set'
  error_map['auth_modify'][0x39] = 'Option #3 and Swap_Unswap# and Half_Device_Swap_Active are equal (device is already in the requested swap state)'
