import json
import logging

LOG_CONFIG_JSON_FILE_NAME = "logconfig.json"

def setup_app_logging(verbose: bool=False):
  try:
    with open(LOG_CONFIG_JSON_FILE_NAME) as json_file:
      log_config_dict = json.load(json_file)
      import logging.config
      logging.config.dictConfig(log_config_dict)
  except FileNotFoundError as ex:
    if verbose:
      mylevel = logging.INFO
    else:
      mylevel = logging.WARNING
    logging.basicConfig(level=mylevel, format='%(asctime)s %(name)-17s %(levelname)-8s %(message)s')
    print(ex)
    print('WARN: Logging configuration file "{}" not found. Using default logging.'.format(LOG_CONFIG_JSON_FILE_NAME))
