///
/// @file platform_driver_server_svc_indigo.h
///
/// @brief Micron Indigo SDK GRPC server Indigo services
///
/// @copyright (C) 2019 Micron Technology, Inc. All rights reserved.
///

#ifndef _PLATFORM_DRIVER_SERVER_SVC_INDIGO_H
#define _PLATFORM_DRIVER_SERVER_SVC_INDIGO_H

#include "../platform_driver.grpc.pb.h"

class IndigoServiceImpl final : public authenta::Indigo::Service
{
    grpc::Status Request_UID(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;
        
    grpc::Status Provision_CRTM(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status Deprovision_CRTM(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;    

    grpc::Status APA_Modify(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status Flash_Extend(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status ACRTM_Update_Start(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status ACRTM_Update_Finish(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;     

    grpc::Status CRTM_Register_Read(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status CRTM_Register_Write(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status Replace_SRK(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status Manage_KTS(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override; 

    grpc::Status Measure(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status PCR_Extend(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status CreateSignature(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status VerifySignature(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status Request_Monotonic_Counter(
        grpc::ServerContext *context,
        const authenta::indigo_content *request,
        authenta::message_return *reply) override;

    grpc::Status Read_Multiple_Block(
        grpc::ServerContext *context,
        const authenta::flash_address *request,
        authenta::message_return *reply) override;

    grpc::Status Write_Multiple_Block(
        grpc::ServerContext *context,
        const authenta::flash_write_content *request,
        authenta::status_type_msg *reply) override;

    grpc::Status Authenta_device_open(
        grpc::ServerContext *context,
        const authenta::string_msg *request,
        authenta::device_descriptor *reply) override;

    grpc::Status Authenta_device_close(
        grpc::ServerContext *context,
        const authenta::int_msg *request,
        authenta::status_type_msg *reply) override;

    grpc::Status Acquire_Device(
        grpc::ServerContext *context,
        const authenta::int_msg *request,
        authenta::status_type_msg *reply) override;

    grpc::Status Release_Device(
        grpc::ServerContext *context,
        const authenta::int_msg *request,
        authenta::status_type_msg *reply) override;

    grpc::Status Authenta_detect_devices(
        grpc::ServerContext *context,
        const authenta::void_msg *request,
        authenta::list_info *reply) override;
};

#endif // _PLATFORM_DRIVER_SERVER_SVC_INDIGO_H
