///
/// @file platform_driver_server_ll.cc
///
/// @brief Micron SDK2 GRPC server device linked list management lib
///
/// @copyright (C) 2019 Micron Technology, Inc. All rights reserved.
///

#ifndef _PLATFORM_DRIVER_SERVER_LL_H
#define _PLATFORM_DRIVER_SERVER_LL_H

#include <stdbool.h>

#ifdef __cplusplus
extern "C" {
#endif

struct device_mt_info{
    int fd;
    bool acquired;
    char path[256];
    struct device_mt_info * next;
};

enum device_ll_operation_result {
	DEVICE_NOT_FOUND = 0,
	DEVICE_ACQUIRED = 1,
	DEVICE_BUSY = 2,
	DEVICE_FREE = 3,
    DEVICE_NOT_OWNED = 4
};
typedef enum device_ll_operation_result ll_result;

struct device_mt_info *add_head(
    struct device_mt_info *former_head,
    int nfd,
    const char *npath);

struct device_mt_info *remove_element(
    struct device_mt_info *old_head,
    int fd);

ll_result acquire_device(struct device_mt_info *old_head, int fd);

ll_result release_device(struct device_mt_info *old_head, int fd);

bool check_control(struct device_mt_info *old_head, int fd);

#ifdef __cplusplus
}
#endif

#endif // _PLATFORM_DRIVER_SERVER_LL_H
