#! /usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Jul 20 2020

@author: marshall shapiro
"""
 
 
import os
import logging
import authenta.kms_proxy.crypto_utils as cr
from   Cryptodome.PublicKey import RSA
from   Cryptodome.Cipher import AES
from   Cryptodome.Cipher import PKCS1_OAEP
from   Cryptodome.Hash import SHA256
from   Cryptodome.Signature import pss


logger = logging.getLogger(__name__)

_PRINT_TIMING_ = False

def generate_rsa_encryption_keys():
    ######### Generate keys#################################################
    print("Creating RSA key pair in folder ./tmp.")
    print("Please be patient. This may take a while...")
    try:
        if not os.path.exists('./tmp'):
            os.makedirs('./tmp')
        privatekey = cr.generate_key("./tmp/kms_rsa_encryption_key.prv","./tmp/kms_rsa_encryption_key.pub")

        if privatekey is not None:
            print("succesfully generated keys into files ./tmp/kms_rsa_encryption_key.prv and ./tmp/kms_rsa_encryption_key.pub")
        else:
            print("Failed to generate keys: ./tmp/kms_rsa_encryption_key.prv and ./tmp/kms_rsa_encryption_key.pub")
    except OSError as err:
        print("{}: {}".format(type(err), err))
        print("Failed to generate keys")


# program entry point
if __name__ == "__main__":
# call main function
   # sys.exit() acts as a thin wrapper -
   # kind of global exception handler
  generate_rsa_encryption_keys()
  exit(0)
