#! /usr/bin/env python3

"""
API Test for Page_Program
(C) 2019 Micron Technology, Inc. All rights reserved.
"""

import pytest

import conftest

@pytest.fixture(scope="module", autouse=True)
def test_page_program_setup(request):
  global device
  device = conftest.get_device(request)

  yield

def test_page_program_Positive():
  with device:
    addr = 0xe40000
    data = b"\x00\x11\x22\x33"

    ret = device.meta_dyb_write(False, addr)
    assert(ret)

    ret = device.meta_page_program(addr, data)
    assert(ret)
