#! /usr/bin/env python3

"""
API Test for Request_Monotonic_Counter.
(C) 2019 Micron Technology, Inc. All rights reserved.
"""

import pytest

import authenta.naxos.utils as utils

import conftest

@pytest.fixture(scope="module", autouse=True)
def test_request_monotonic_counter_setup(request):
  global device
  global provision_stats
  device = conftest.get_device(request)

  with device:
    ret = utils.get_dev_info(device)
    assert(ret != None)
    (_, _, _, provision_stats) = ret

  yield

def test_request_monotonic_counter_Positive_Amtc0():
  if provision_stats.Provisioned == 0:
    return

  with device:
    err, _ = device.meta_request_monotonic_counter(0x80)
    assert(err.esr_and_response_success)

def test_request_monotonic_counter_Positive_Amtc1():
  if provision_stats.Provisioned == 0:
    return

  with device:
    err, _ = device.meta_request_monotonic_counter(0x81)
    assert(err.esr_and_response_success)

def test_request_monotonic_counter_Negative_NotProvisioned():
  """
  Not provisioned
  """
  if provision_stats.Provisioned == 0:
    with device:
      err, _ = device.meta_request_monotonic_counter(0x80)
      assert(err.esr != b"\x80")